// Autor: Sebastian Rieder
// Unterstützen Sie mich: https://www.paypal.com/donate/?hosted_button_id=RZ822WZ9HRZPS
// Version: 1.0
// Author URI: https://www.zeilenhoehe.de/

// Dialogfeld zur Eingabe der gewünschten Fläche in Quadratmillimetern
var targetAreaMm2 = prompt("Bitte geben Sie die gewünschte Fläche in Quadratmillimetern ein:", "100"); // Beispiel: 100 mm²

// Überprüfen, ob der Benutzer auf "Abbrechen" geklickt hat
if (targetAreaMm2 !== null) {
    // 1 Millimeter = 2.83465 Punkte
    var mmToPoint = 2.83465;

    // Zielgröße in Punkten berechnen
    var targetAreaPt2 = targetAreaMm2 * mmToPoint * mmToPoint;

    // Funktion zum Skalieren eines Logos
    function scaleLogoToArea(item, targetArea) {
        // Originale Breite und Höhe
        var originalWidth = item.width;
        var originalHeight = item.height;
        // Originale Fläche
        var originalArea = originalWidth * originalHeight;
        // Skalierungsfaktor berechnen
        var scaleFactor = Math.sqrt(targetArea / originalArea);
        // Neue Breite und Höhe
        var newWidth = originalWidth * scaleFactor;
        var newHeight = originalHeight * scaleFactor;
        // Skalieren des Logos
        item.resize(scaleFactor * 100, scaleFactor * 100);
    }

    // Auswahl des aktuellen Dokuments
    var doc = app.activeDocument;
    // Über alle ausgewählten Elemente iterieren
    for (var i = 0; i < doc.selection.length; i++) {
        var selectedItem = doc.selection[i];
        scaleLogoToArea(selectedItem, targetAreaPt2);
    }
}